package com.mowerm.opentools.clippy;

import java.awt.*;

import javax.swing.*;

import com.borland.primetime.ide.*;

/**
 *  A <code>BufferCellRenderer</code> renders the contents of a buffer slot for
 *  use in a <code>JList</code> UI component.<p>
 *
 *  This source code is hereby placed in the public domain.<p>
 *
 *
 *
 *@author     Matt Mower <matt_mower@hotmail.com>
 *@created    June 27, 2001
 *@version    1.0
 */
public class BufferCellRenderer extends JPanel implements ListCellRenderer {
	/**
	 *  Description of the Field
	 */
	private JTextArea text = new JTextArea();

	/**
	 *  Description of the Field
	 */
	private JLabel icon = new JLabel();

	/**
	 *  Description of the Field
	 */
	private BorderLayout layout = new BorderLayout();


	/**
	 *  Materialize a new <code>BufferCellRenderer</code> .<p>
	 *
	 *
	 */
	public BufferCellRenderer() {
		try {
			jbInit();
		} catch( Exception _ex ) {
			_ex.printStackTrace();
		}
	}


	/**
	 *@param  _list          Description of Parameter
	 *@param  _value         Description of Parameter
	 *@param  _index         Description of Parameter
	 *@param  _isSelected    Description of Parameter
	 *@param  _cellHasFocus  Description of Parameter
	 *@return                todo: describe return value
	 *@todo:                 describe method
	 */
	public Component getListCellRendererComponent( JList _list, Object _value, int _index, boolean _isSelected, boolean _cellHasFocus ) {
		if( _index == -1 ) {
			int _selected = _list.getSelectedIndex();
			if( _selected == -1 ) {
				return this;
			}
			_index = _selected;
		}

		String _text = ( String ) _value;
		text.setText( _text );
		if( _isSelected ) {
			text.setForeground( Color.yellow );
			text.setBackground( Color.black );
		} else {
			text.setForeground( Color.black );
			text.setBackground( Color.white );
		}

		icon.setIcon( _text.equals( "<empty>" ) ? BrowserIcons.ICON_COPY : BrowserIcons.ICON_PASTE );
		return this;
	}


	/**
	 *  Description of the Method
	 *
	 *@exception  Exception  Description of Exception
	 */
	private void jbInit() throws Exception {
		setLayout( layout );
		setBorder( BorderFactory.createLineBorder( Color.black ) );
		add( icon, BorderLayout.WEST );
		add( text, BorderLayout.CENTER );
		text.setFont( new java.awt.Font( "SansSerif", 0, 12 ) );
	}
}
