package com.mowerm.opentools.clippy;

import com.borland.primetime.ide.*;

/**
 * The <code>ClippyBrowserListener</code> listens for an event from the browser indicating that it is closing / closed.  This
 * signals Clippy to save the contents of the clipboard buffer ready for the next session.<p>
 *
 * This source code is hereby placed in the public domain.<p>
 *
 *@author     Matt Mower <matt_mower@hotmail.com>
 *@created    June 28, 2001
 *@version    1.0
 */

public class ClippyBrowserListener extends BrowserAdapter {

	/**
	 *  Materialize a new <code>ClippyBrowserListener</code> .<p>
	 *
	 *
	 */
	public ClippyBrowserListener() {
	}


	/**
	 *  Description of the Method
	 */
	public static void register() {
		Browser.addStaticBrowserListener( new ClippyBrowserListener() );
	}


	/**
	 *  Description of the Method
	 *
	 *@param  parm1  Description of Parameter
	 */
	public void browserClosed( Browser parm1 ) {
		Clippy.debug( "Clippy : browser count is now " + Browser.getBrowserCount() );
		if( Browser.getBrowserCount() == 0 ) {
			Clippy.debug( "Clippy : JBuilder is closing, saving buffers" );
			Clippy.getBufferManager().saveBuffers();
		}
	}
}
