package com.mowerm.opentools.clippy;

import java.awt.*;

import javax.swing.*;

import com.borland.primetime.help.*;
import com.borland.primetime.properties.*;

/**
 *  <code>ClippyPropertiesPage</code> is a UI representation of the Clippy
 *  properties allowing them to be edited in the JBuilder IDE properties panel.
 *  <p>
 *
 *  This source code is hereby placed in the public domain.<p>
 *
 *
 *
 *@author     Matt Mower <matt_mower@hotmail.com>
 *@created    June 26, 2001
 *@version    1.0
 */

public class ClippyPropertiesPage extends PropertyPage {
	/**
	 *  Description of the Field
	 */
	JPanel jPanel1 = new JPanel();

	/**
	 *  Description of the Field
	 */
	BorderLayout borderLayout1 = new BorderLayout();

	/**
	 *  Description of the Field
	 */
	GridBagLayout gridBagLayout1 = new GridBagLayout();

	/**
	 *  Description of the Field
	 */
	JSlider buffersSlider = new JSlider();

	/**
	 *  Description of the Field
	 */
	JLabel jLabel1 = new JLabel();

	/**
	 *  Description of the Field
	 */
	JCheckBox chkCopyRingMode = new JCheckBox();

	/**
	 *  Description of the Field
	 */
	JCheckBox chkPasteRingMode = new JCheckBox();

	/**
	 *  Description of the Field
	 */
	JCheckBox chkBypassSystemClipboardMode = new JCheckBox();
	/**
	 *  Description of the Field
	 */
	JCheckBox chkBeepConfirmationMode = new JCheckBox();
	/**
	 *  Description of the Field
	 */
	JCheckBox chkDebugMode = new JCheckBox();
	/**
	 *  Description of the Field
	 */
	JCheckBox chkAutoBindKeymapMode = new JCheckBox();


	/**
	 *  Description of the Field
	 */
	public ClippyPropertiesPage() {
		try {
			jbInit();
		} catch( Exception _ex ) {
			_ex.printStackTrace();
		}
	}


	/**
	 *  Gets the HelpTopic attribute of the ClippyPropertiesPage object
	 *
	 *@return    The HelpTopic value
	 */
	public HelpTopic getHelpTopic() {
		return null;
	}


	/**
	 *  Description of the Method
	 */
	public void writeProperties() {
		Clippy.setDebugModeEnabled( chkDebugMode.isSelected() );
		Clippy.setCopyRingModeEnabled( chkCopyRingMode.isSelected() );
		Clippy.setPasteRingModeEnabled( chkPasteRingMode.isSelected() );
		Clippy.setBypassSystemClipboardModeEnabled( chkBypassSystemClipboardMode.isSelected() );
		Clippy.setBeepConfirmationModeEnabled( chkBeepConfirmationMode.isSelected() );
		Clippy.setAutoBindKeymapModeEnabled( chkAutoBindKeymapMode.isSelected() );
		// Dont unnecessarily reset the buffers
		if( buffersSlider.getValue() != Clippy.getBufferCount() ) {
			Clippy.setBufferCount( buffersSlider.getValue() );
		}
	}


	/**
	 *  Description of the Method
	 */
	public void readProperties() {
		chkDebugMode.setSelected( Clippy.isDebugModeEnabled() );
		chkCopyRingMode.setSelected( Clippy.isCopyRingModeEnabled() );
		chkPasteRingMode.setSelected( Clippy.isPasteRingModeEnabled() );
		chkBypassSystemClipboardMode.setSelected( Clippy.isBypassSystemClipboardModeEnabled() );
		chkBeepConfirmationMode.setSelected( Clippy.isBeepConfirmationModeEnabled() );
		chkAutoBindKeymapMode.setSelected( Clippy.isAutoBindKeymapModeEnabled() );
		buffersSlider.setValue( Clippy.getBufferCount() );
	}


	/**
	 *  Description of the Method
	 *
	 *@exception  Exception  Description of Exception
	 */
	private void jbInit() throws Exception {
		this.setLayout( borderLayout1 );
		jPanel1.setLayout( gridBagLayout1 );
		jLabel1.setText( "Number of Buffers" );
		chkCopyRingMode.setForeground( new Color( 102, 102, 153 ) );
		chkCopyRingMode.setText( "Copy Ring Mode" );
		chkPasteRingMode.setForeground( new Color( 102, 102, 153 ) );
		chkPasteRingMode.setText( "Paste Ring Mode" );
		chkBypassSystemClipboardMode.setForeground( new Color( 102, 102, 153 ) );
		chkBypassSystemClipboardMode.setToolTipText( "" );
		chkBypassSystemClipboardMode.setText( "Bypass System Clipboard" );
		buffersSlider.setMajorTickSpacing( 4 );
		buffersSlider.setMaximum( 32 );
		buffersSlider.setMinimum( 4 );
		buffersSlider.setMinorTickSpacing( 2 );
		buffersSlider.setPaintLabels( true );
		buffersSlider.setPaintTicks( true );
		chkBeepConfirmationMode.setForeground( new Color( 102, 102, 153 ) );
		chkBeepConfirmationMode.setText( "Beep to confirm operations" );
		chkDebugMode.setForeground( new Color( 102, 102, 153 ) );
		chkDebugMode.setText( "Debug Mode" );
		chkAutoBindKeymapMode.setForeground( new Color( 102, 102, 153 ) );
		chkAutoBindKeymapMode.setText( "Automatically bind keymap" );
		this.add( jPanel1, BorderLayout.CENTER );
		jPanel1.add( buffersSlider, new GridBagConstraints( 0, 1, 2, 1, 0.0, 0.0
				, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
		jPanel1.add( jLabel1, new GridBagConstraints( 0, 0, 2, 1, 0.0, 0.0
				, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
		jPanel1.add( chkCopyRingMode, new GridBagConstraints( 0, 2, 2, 1, 0.0, 0.0
				, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
		jPanel1.add( chkPasteRingMode, new GridBagConstraints( 0, 3, 2, 1, 0.0, 0.0
				, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
		jPanel1.add( chkBypassSystemClipboardMode, new GridBagConstraints( 0, 4, 2, 1, 0.0, 0.0
				, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
		jPanel1.add( chkBeepConfirmationMode, new GridBagConstraints( 0, 5, 2, 1, 0.0, 0.0
				, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 5, 5, 0, 5 ), 0, 0 ) );
		jPanel1.add( chkDebugMode, new GridBagConstraints( 0, 7, 2, 1, 0.0, 0.0
				, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 5, 5, 5 ), 0, 0 ) );
		jPanel1.add( chkAutoBindKeymapMode, new GridBagConstraints( 0, 6, 2, 1, 0.0, 0.0
				, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 5, 5, 5, 5 ), 0, 0 ) );
	}

}
