package com.mowerm.opentools.clippy;

import java.awt.*;
import java.awt.datatransfer.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;

import com.borland.primetime.ide.*;

/**
 *  A dialog that allows the user to manage the contents of their buffers.<p>
 *
 *  This source code is hereby placed in the public domain.<p>
 *
 *
 *
 *@author     Matt Mower <matt_mower@hotmail.com>
 *@created    June 26, 2001
 *@version    1.0
 */

public class ManageBuffersDialog extends JDialog {

	/**
	 *  Description of the Field
	 */
	public Dimension layoutSize = new Dimension( 640, 480 );
	/**
	 *  Description of the Field
	 */
	JPanel layoutPanel = new JPanel();
	/**
	 *  Description of the Field
	 */
	BorderLayout borderLayout1 = new BorderLayout();
	/**
	 *  Description of the Field
	 */
	JScrollPane bufferScroller = new JScrollPane();
	/**
	 *  Description of the Field
	 */
	JList bufferList = new JList();
	/**
	 *  Description of the Field
	 */
	JPanel listPanel = new JPanel();
	/**
	 *  Description of the Field
	 */
	BorderLayout borderLayout2 = new BorderLayout();

	/**
	 *  Description of the Field
	 */
	BufferCellRenderer renderer = new BufferCellRenderer();
	/**
	 *  Description of the Field
	 */
	JPanel buttonPanel = new JPanel();
	/**
	 *  Description of the Field
	 */
	JPanel jPanel1 = new JPanel();
	/**
	 *  Description of the Field
	 */
	JPanel jPanel2 = new JPanel();
	/**
	 *  Description of the Field
	 */
	JPanel jPanel3 = new JPanel();
	/**
	 *  Description of the Field
	 */
	JButton cancelButton = new JButton();
	/**
	 *  Description of the Field
	 */
	JButton okButton = new JButton();
	/**
	 *  Description of the Field
	 */
	BorderLayout borderLayout3 = new BorderLayout();
	/**
	 *  Description of the Field
	 */
	JButton downButton = new JButton();
	/**
	 *  Description of the Field
	 */
	JButton upButton = new JButton();
	/**
	 *  Description of the Field
	 */
	JButton importButton = new JButton();
	/**
	 *  Description of the Field
	 */
	JButton clearButton = new JButton();


	/**
	 *  Materialize a new <code>BufferSelectDialog</code> .<p>
	 *
	 *
	 *
	 *@param  frame  Description of Parameter
	 *@param  title  Description of Parameter
	 *@param  modal  Description of Parameter
	 */
	public ManageBuffersDialog( Frame frame, String title, boolean modal ) {
		super( frame, title, modal );
		try {
			jbInit();
		} catch( Exception ex ) {
			ex.printStackTrace();
		}
	}



	/**
	 *  Materialize a new <code>BufferSelectDialog</code> .<p>
	 *
	 *
	 */
	public ManageBuffersDialog() {
		this( null, "Manage Clippy Buffers", false );
	}


	/**
	 *  Sets the LayoutSize attribute of the ManageBuffersDialog object
	 *
	 *@param  _width   The new LayoutSize value
	 *@param  _height  The new LayoutSize value
	 */
	public void setLayoutSize( int _width, int _height ) {
		layoutSize = new Dimension( _width, _height );
		Clippy.debug( "Layout size = " + layoutSize.toString() );
	}


	/**
	 *  Sets the BufferList attribute of the BufferSelectDialog object
	 */
	public void setBufferList() {
		try {
			Clipboard[] _clipboards = Clippy.getBufferManager().getBuffers();

			String[] _contents = new String[_clipboards.length];
			for( int _clipboardIndex = 0; _clipboardIndex < _clipboards.length; ++_clipboardIndex ) {
				_contents[_clipboardIndex] = Clippy.getBufferManager().getBufferAsString( _clipboardIndex );
			}

			bufferList.setListData( _contents );
			bufferList.repaint();
		} catch( Throwable _t ) {
			Browser.getActiveBrowser().getStatusView().setText( " : Clippy : Error : Cannot set buffer list : " + _t.getClass().getName() + " : " + _t.getMessage() );
			_t.printStackTrace();
		}
	}


	/**
	 *  Sets the Visible attribute of the BufferSelectDialog object
	 *
	 *@param  _visible  The new Visible value
	 */
	public void setVisible( boolean _visible ) {
		if( _visible ) {
			setBufferList();
		}
		super.setVisible( _visible );
		bufferList.setSelectedIndex( 0 );
		bufferList.requestFocus();
	}


	/**
	 *  Gets the LayoutSize attribute of the ManageBuffersDialog object
	 *
	 *@return    The LayoutSize value
	 */
	public Dimension getLayoutSize() {
		return layoutSize;
	}


	/**
	 *  Description of the Method
	 */
	public void packAndShow() {
		pack();
		Dimension _screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension _dialogSize = getLayoutSize();
		if( _dialogSize.height > _screenSize.height ) {
			_dialogSize.height = _screenSize.height;
		}
		if( _dialogSize.width > _screenSize.width ) {
			_dialogSize.width = _screenSize.width;
		}

		int _displayX = ( _screenSize.width - _dialogSize.width ) / 2;
		int _displayY = ( _screenSize.height - _dialogSize.height ) / 2;

		Clippy.debug( "Showing buffer select dialog:" );
		Clippy.debug( "->Screen size = " + _screenSize.width + " x " + _screenSize.height );
		Clippy.debug( "->Dialog size = " + _dialogSize.width + " x " + _dialogSize.height );
		Clippy.debug( "->Display pos = " + _displayX + " x " + _displayY );

		setLocation( _displayX, _displayY );
		setSize( _dialogSize );
		setVisible( true );
	}


	/**
	 *  Description of the Method
	 *
	 *@exception  Exception  Description of Exception
	 */
	void jbInit() throws Exception {
		layoutPanel.setLayout( borderLayout1 );
		layoutPanel.setBorder( BorderFactory.createEtchedBorder() );
		layoutPanel.setMinimumSize( layoutSize );
		layoutPanel.setPreferredSize( layoutSize );
		bufferList.setCellRenderer( renderer );
		bufferList.setBorder( BorderFactory.createLoweredBevelBorder() );
		bufferList.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
		bufferList.addListSelectionListener(
			new javax.swing.event.ListSelectionListener() {
				/**
				 *  Description of the Method
				 *
				 *@param  e  Description of Parameter
				 */
				public void valueChanged( ListSelectionEvent e ) {
					bufferList_valueChanged( e );
				}
			} );
		bufferList.addKeyListener(
			new java.awt.event.KeyAdapter() {
				/**
				 *  Description of the Method
				 *
				 *@param  e  Description of Parameter
				 */
				public void keyPressed( KeyEvent e ) {
					bufferList_keyPressed( e );
				}
			} );
		listPanel.setLayout( borderLayout2 );
		cancelButton.setMaximumSize( new Dimension( 83, 27 ) );
		cancelButton.setMinimumSize( new Dimension( 83, 27 ) );
		cancelButton.setPreferredSize( new Dimension( 83, 27 ) );
		cancelButton.setToolTipText( "Close the dialog without changing the current buffer" );
		cancelButton.setMnemonic( '0' );
		cancelButton.setText( "Cancel" );
		cancelButton.addActionListener(
			new java.awt.event.ActionListener() {
				/**
				 *  Description of the Method
				 *
				 *@param  e  Description of Parameter
				 */
				public void actionPerformed( ActionEvent e ) {
					cancelButton_actionPerformed( e );
				}
			} );
		okButton.setMaximumSize( new Dimension( 83, 27 ) );
		okButton.setMinimumSize( new Dimension( 83, 27 ) );
		okButton.setPreferredSize( new Dimension( 83, 27 ) );
		okButton.setToolTipText( "Close the dialog with the current buffer selected" );
		okButton.setText( "Ok" );
		okButton.setEnabled( false );
		okButton.addActionListener(
			new java.awt.event.ActionListener() {
				/**
				 *  Description of the Method
				 *
				 *@param  e  Description of Parameter
				 */
				public void actionPerformed( ActionEvent e ) {
					okButton_actionPerformed( e );
				}
			} );
		buttonPanel.setLayout( borderLayout3 );
		downButton.setMaximumSize( new Dimension( 83, 27 ) );
		downButton.setMinimumSize( new Dimension( 83, 27 ) );
		downButton.setPreferredSize( new Dimension( 83, 27 ) );
		downButton.setToolTipText( "Move the current selection down the buffer list" );
    downButton.setMnemonic('D');
		downButton.setText( "Down" );
		downButton.addActionListener(
			new java.awt.event.ActionListener() {
				/**
				 *  Description of the Method
				 *
				 *@param  e  Description of Parameter
				 */
				public void actionPerformed( ActionEvent e ) {
					downButton_actionPerformed( e );
				}
			} );
		upButton.setMaximumSize( new Dimension( 83, 27 ) );
		upButton.setMinimumSize( new Dimension( 83, 27 ) );
		upButton.setPreferredSize( new Dimension( 83, 27 ) );
		upButton.setToolTipText( "Move the contents of the current buffer up the list" );
    upButton.setMnemonic('U');
		upButton.setText( "Up" );
		upButton.addActionListener(
			new java.awt.event.ActionListener() {
				/**
				 *  Description of the Method
				 *
				 *@param  e  Description of Parameter
				 */
				public void actionPerformed( ActionEvent e ) {
					upButton_actionPerformed( e );
				}
			} );
		importButton.setMaximumSize( new Dimension( 83, 27 ) );
		importButton.setMinimumSize( new Dimension( 83, 27 ) );
		importButton.setPreferredSize( new Dimension( 83, 27 ) );
		importButton.setToolTipText( "Overwrite the current buffer with the system clipboard" );
    importButton.setMnemonic('I');
		importButton.setText( "Import" );
		importButton.addActionListener(
			new java.awt.event.ActionListener() {
				/**
				 *  Description of the Method
				 *
				 *@param  e  Description of Parameter
				 */
				public void actionPerformed( ActionEvent e ) {
					importButton_actionPerformed( e );
				}
			} );
		clearButton.setMaximumSize( new Dimension( 83, 27 ) );
		clearButton.setMinimumSize( new Dimension( 83, 27 ) );
		clearButton.setPreferredSize( new Dimension( 83, 27 ) );
    clearButton.setMnemonic('C');
		clearButton.setText( "Clear" );
		clearButton.addActionListener(
			new java.awt.event.ActionListener() {
				/**
				 *  Description of the Method
				 *
				 *@param  e  Description of Parameter
				 */
				public void actionPerformed( ActionEvent e ) {
					clearButton_actionPerformed( e );
				}
			} );
		this.addComponentListener(
			new java.awt.event.ComponentAdapter() {
				/**
				 *  Description of the Method
				 *
				 *@param  e  Description of Parameter
				 */
				public void componentResized( ComponentEvent e ) {
					this_componentResized( e );
				}
			} );
		jPanel2.add( okButton, null );
		jPanel2.add( cancelButton, null );
		getContentPane().add( layoutPanel );
		layoutPanel.add( bufferScroller, BorderLayout.CENTER );
		layoutPanel.add( buttonPanel, BorderLayout.SOUTH );
		bufferScroller.getViewport().add( listPanel, null );
		listPanel.add( bufferList, BorderLayout.CENTER );
		buttonPanel.add( jPanel3, BorderLayout.WEST );
		buttonPanel.add( jPanel1, BorderLayout.CENTER );
		jPanel1.add( clearButton, null );
		jPanel1.add( importButton, null );
		buttonPanel.add( jPanel2, BorderLayout.EAST );
		jPanel3.add( upButton, null );
		jPanel3.add( downButton, null );
	}


	/**
	 *  Description of the Method
	 */
	void select() {
		Clippy.getBufferManager().setCurrentBuffer( bufferList.getSelectedIndex() );
		Browser.getActiveBrowser().getStatusView().setText( " Selected buffer now: " + Clippy.getBufferManager().getBufferDisplayNumber() );
	}


	/**
	 *  Description of the Method
	 *
	 *@param  e  Description of Parameter
	 */
	void cancelButton_actionPerformed( ActionEvent e ) {
		setVisible( false );
	}


	/**
	 *  Description of the Method
	 *
	 *@param  e  Description of Parameter
	 */
	void okButton_actionPerformed( ActionEvent e ) {
		select();
		setVisible( false );
	}


	/**
	 *  Description of the Method
	 *
	 *@param  e  Description of Parameter
	 */
	void bufferList_valueChanged( ListSelectionEvent e ) {
		if( e.getValueIsAdjusting() || e.getFirstIndex() == -1 ) {
			okButton.setEnabled( false );
		} else {
			okButton.setEnabled( true );
		}

		ListModel _model = bufferList.getModel();
		upButton.setEnabled( bufferList.getSelectedIndex() > 0 );
		downButton.setEnabled( bufferList.getSelectedIndex() < ( _model.getSize() - 1 ) );
	}


	/**
	 *  Description of the Method
	 *
	 *@param  e  Description of Parameter
	 */
	void bufferList_keyPressed( KeyEvent e ) {
		Clippy.debug( "Clippy : buffer list : gets key: " + e.toString() );
		Clippy.debug( "Clippy : buffer list : looking for code = " + KeyEvent.VK_ESCAPE );
		Clippy.debug( "Clippy : buffer list : Found code =       " + e.getKeyCode() );

		if( e.getKeyCode() == KeyEvent.VK_ENTER ) {
			select();
			setVisible( false );
		} else if( e.getKeyCode() == KeyEvent.VK_ESCAPE ) {
			setVisible( false );
		}
	}


	/**
	 *  Description of the Method
	 *
	 *@param  e  Description of Parameter
	 */
	void upButton_actionPerformed( ActionEvent e ) {
		int _selectedIndex = bufferList.getSelectedIndex();
		Clippy.getBufferManager().swapBuffers( _selectedIndex - 1, _selectedIndex );
		updateBufferList( _selectedIndex - 1 );
	}


	/**
	 *  Description of the Method
	 *
	 *@param  e  Description of Parameter
	 */
	void downButton_actionPerformed( ActionEvent e ) {
		int _selectedIndex = bufferList.getSelectedIndex();
		Clippy.getBufferManager().swapBuffers( _selectedIndex, _selectedIndex + 1 );
		updateBufferList( _selectedIndex + 1 );
	}


	/**
	 *  Description of the Method
	 *
	 *@param  e  Description of Parameter
	 */
	void importButton_actionPerformed( ActionEvent e ) {
		Clippy.getBufferManager().copySystemClipboardToBuffer( bufferList.getSelectedIndex() );
		setBufferList();
	}


	/**
	 *  Description of the Method
	 *
	 *@param  _selectedIndex  Description of Parameter
	 */
	void updateBufferList( int _selectedIndex ) {
		setBufferList();
		bufferList.requestFocus();
		bufferList.setSelectedIndex( _selectedIndex );
		bufferList.scrollRectToVisible( bufferList.getCellBounds( _selectedIndex, _selectedIndex ) );
	}


	/**
	 *  Description of the Method
	 *
	 *@param  e  Description of Parameter
	 */
	void clearButton_actionPerformed( ActionEvent e ) {
		Clippy.getBufferManager().setBufferContents( bufferList.getSelectedIndex(), new StringSelection( "" ) );
		updateBufferList( bufferList.getSelectedIndex() );
	}


	/**
	 *  Description of the Method
	 *
	 *@param  _event  Description of Parameter
	 */
	void this_componentResized( ComponentEvent _event ) {
		Clippy.setBufferManagerDialogWidth( getSize().width );
		Clippy.setBufferManagerDialogHeight( getSize().height );
	}
}
