package com.mowerm.opentools.clippy.actions;

import javax.swing.*;

import com.mowerm.opentools.clippy.*;

/**
 *  This source code is hereby placed in the public domain.<p>
 *
 *
 *
 *@author     Matt Mower <matt_mower@hotmail.com>
 *@created    July 4, 2001
 *@version    1.0
 */

public class ImportSystemClipboardToBufferAction extends EditorAction {

	/**
	 *  Materialize a new <code>ImportSystemClipboardToBufferAction</code> .<p>
	 *
	 *
	 */
	public ImportSystemClipboardToBufferAction() {
		super( "import-system-clipboard-to-buffer" );
		putValue( Action.LONG_DESCRIPTION, "Copies System clipboard contents to the current buffer" );
		putValue( "ActionGroup", "Clippy" );
	}


	/**
	 *  Informs the buffer manager that the contents of the system clipoard should
	 *  be copied into the current buffer.<p>
	 *
	 *
	 */
	public void editActionPerformed() {
		Clippy.getBufferManager().copySystemClipboardToBuffer();
		setStatus( " Clippy : System clipboard imported to current buffer" );
		if( Clippy.isBeepConfirmationModeEnabled() ) {
			getEditorPane().getToolkit().beep();
		}
	}
}
