package com.mowerm.opentools.clippy.actions;

import javax.swing.*;

import com.mowerm.opentools.clippy.*;

/**
 *  This source code is hereby placed in the public domain.<p>
 *
 *
 *
 *@author     Matt Mower <matt_mower@hotmail.com>
 *@created    June 25, 2001
 *@version    1.0
 */

public class SelectBufferAction extends EditorAction {
	/**
	 *  Description of the Field
	 */
	private ManageBuffersDialog dialog = new ManageBuffersDialog();


	/**
	 *  Materialize a new <code>SelectBufferAction</code> .<p>
	 *
	 *
	 */
	public SelectBufferAction() {
		super( "select-buffer" );
		putValue( Action.LONG_DESCRIPTION, "Pops up buffer selector" );
		putValue( "ActionGroup", "Clippy" );
	}


	/**
	 *  Description of the Method
	 */
	public void editActionPerformed() {
		try {
			dialog.setLayoutSize( Clippy.getBufferManagerDialogWidth(), Clippy.getBufferManagerDialogHeight() );
			dialog.packAndShow();
			dialog.toFront();
		} catch( Throwable _t ) {
			Clippy.debug( "Error in buffer select", _t );
			setStatus( " Clippy : Error in buffer select : " + _t.getClass().getName() + " : " + _t.getMessage() );
		}
	}
}
