package com.mowerm.opentools.clippy.actions;

import javax.swing.*;

import com.mowerm.opentools.clippy.*;

/**
 *  This source code is hereby placed in the public domain.<p>
 *
 *
 *
 *@author     Matt Mower <matt_mower@hotmail.com>
 *@created    June 25, 2001
 *@version    1.0
 */

public class SelectBufferXAction extends EditorAction {
	/**
	 *  Index of the buffer that this action will select.
	 */
	private int bufferIndex;


	/**
	 *  Materialize a new <code>SelectBufferXAction</code> .<p>
	 *
	 *
	 *
	 *@param  _bufferIndex  Description of Parameter
	 */
	public SelectBufferXAction( int _bufferIndex ) {
		super( "select-buffer-" + ( _bufferIndex + 1 ) );
		putValue( Action.LONG_DESCRIPTION, "Selects buffer: " + ( _bufferIndex + 1 ) );
		putValue( "ActionGroup", "Clippy" );
		bufferIndex = _bufferIndex;
	}


	/**
	 *  Select the specified buffer.<p>
	 *
	 *
	 */
	public void editActionPerformed() {
		try {
			Clippy.getBufferManager().setCurrentBuffer( bufferIndex );
			setStatus( " Current buffer now: [" + Clippy.getBufferManager().getBufferDisplayNumber() + "] '" + Clippy.getBufferManager().getBufferSummary() + "'" );
		} catch( Throwable _t ) {
			Clippy.debug( "Error in buffer select", _t );
			setStatus( " Clippy : Error in buffer select : " + _t.getClass().getName() + " : " + _t.getMessage() );
		}
	}
}
