package com.mowerm.opentools.clippy.actions;

import javax.swing.*;

import com.mowerm.opentools.clippy.*;

/**
 *  This source code is hereby placed in the public domain.<p>
 *
 *
 *
 *@author     Matt Mower <matt_mower@hotmail.com>
 *@created    June 26, 2001
 *@version    1.0
 */

public class ToggleRingModeAction extends EditorAction {

	/**
	 *  Materialize a new <code>ToggleRingModeAction</code> .<p>
	 *
	 *
	 */
	public ToggleRingModeAction() {
		super( "toggle-ring-mode" );
		putValue( Action.LONG_DESCRIPTION, "Toggles Clippy's Ring Mode" );
		putValue( "ActionGroup", "Clippy" );
	}


	/**
	 *  Description of the Method
	 */
	public void editActionPerformed() {
		try {
			if( !Clippy.isCopyRingModeEnabled() && !Clippy.isPasteRingModeEnabled() ) {
				Clippy.setCopyRingModeEnabled( true );
			} else if( Clippy.isCopyRingModeEnabled() && !Clippy.isPasteRingModeEnabled() ) {
				Clippy.setPasteRingModeEnabled( true );
			} else {
				Clippy.setCopyRingModeEnabled( false );
				Clippy.setPasteRingModeEnabled( false );
			}

			StringBuffer _statusMessage = new StringBuffer( " Clippy : Ring Mode is " );
			if( !Clippy.isCopyRingModeEnabled() && !Clippy.isPasteRingModeEnabled() ) {
				_statusMessage.append( "disabled" );
			} else if( Clippy.isCopyRingModeEnabled() && !Clippy.isPasteRingModeEnabled() ) {
				_statusMessage.append( "copy-only" );
			} else {
				_statusMessage.append( "copy+paste" );
			}

			setStatus( _statusMessage.toString() );
		} catch( Throwable _t ) {
			Clippy.debug( "Error in toggle ring mode", _t );
			setStatus( " Clippy : Error in ring mode toggle : " + _t.getClass().getName() + " : " + _t.getMessage() );
		}
	}
}
